@import "src/assets/styles/_for-react-components.scss";
@import "../../../../../node_modules/simplebar-react/dist/simplebar.min";
@import "./simpleBar";

$parent: "react-select";

@include block($parent) {
  // Фон селекта
  --rs-bg-color: transparent;

  // Округление селекта
  --rs-border-radius: 0;

  // Цвета границ селекта
  --rs-border-color: var(--color-grey-300);
  --rs-border-color-hover: var(--color-grey-300-50);
  --rs-border-color-menu-is-open: var(--color-grey-300);
  --rs-border-color-is-focused: var(--color-grey-300);

  // Ширина границ селекта
  --rs-border-width: 1px;

  // Цвет текста плейсхолдера
  --rs-placeholder-color: var(--color-grey-500-30);

  // Цвета текста выбранных вариантов селекта
  --rs-color: var(--color-grey-500);
  --rs-color-hover: var(--color-grey-500);
  --rs-color-is-focused: var(--color-grey-500);

  // Цвет иконки состояния селекта (открыт, закрыт)
  --rs-indicator-size: #{rem(16)};
  --rs-indicator-fill: var(--color-grey-500);
  --rs-indicator-stroke: transparent;

  // Округление чекбокса в мультиселекте
  --rs-checkmark-border-radius: 0;

  // Цвет чекбокса в мультиселекте
  --rs-checkmark-fill: var(--color-white-100);
  --rs-checkmark-bg-color: var(--color-white-100);
  --rs-checkmark-bg-color-is-selected: var(--color-grey-500);
  --rs-checkmark-border-color: var(--color-grey-500);
  --rs-checkmark-border-color-is-selected: var(--color-grey-500);

  // Округление выпадающиего спика
  --rs-menu-border-radius: var(--rs-border-radius);

  // Цвета выпадающего списка
  --rs-menu-border-color: var(--color-grey-200);
  --rs-menu-bg-color: var(--color-white-100);

  // Фон варианта в выпадающем списке
  --rs-option-bg-color: var(--color-white-100);
  --rs-option-bg-color-is-selected: var(--color-grey-100);
  --rs-option-bg-color-is-hover: var(--color-grey-100-50);

  // Фон мулти варианта в выпадающем списке
  --rs-multi-option-bg-color-is-selected: var(--color-grey-100);

  // Цвет границ варианта в выпадающем списке
  --rs-option-border-color: transparent;

  // Цвета текста варианта в выпадающем списке
  --rs-option-color: var(--color-grey-500);
  --rs-option-color-is-selected: var(--color-grey-500);
  --rs-option-color-is-focused: var(--color-grey-500);

  // Анимация
  --rs-transition: 0.3s ease;

  height: rem(40);
  min-width: rem(278);

  @include min-media('t') {
    height: rem(48);
  }

  @include element($parent, "control") {
    position: relative;
    display: flex;
    flex-wrap: wrap;
    justify-content: space-between;
    height: 100%;
    padding: 0;
    border-bottom: var(--rs-border-width) solid var(--rs-border-color);
    border-radius: var(--rs-border-radius);
    cursor: pointer;
    color: var(--rs-color);
    background-color: var(--rs-bg-color);
    transition: border-color var(--rs-transition), color var(--rs-transition);

    &:hover {
      border-color: var(--rs-border-color-hover);
      color: var(--rs-color-hover);
    }

    @include modifier($parent, "is-focused") {
      transition: none;
      border-color: var(--rs-border-color-is-focused);
      color: var(--rs-color-is-focused);
    }

    @include modifier($parent, "menu-is-open") {
      border-color: var(--rs-border-color-menu-is-open);
      border-bottom-color: transparent;

      @include element($parent, "indicator") {
        transform: rotate(180deg);
      }
    }
  }

  @include element($parent, "value-container") {
    flex: 1;
    position: relative;
    padding: rem(12) 0;
    overflow: hidden;

    @include min-media('t') {
      padding: rem(16) 0;
    }

    @include modifier($parent, "is-multi") {
      white-space: nowrap;
      text-overflow: ellipsis;
    }
  }

  @include element($parent, "placeholder") {
    display: inline;
    color: var(--rs-placeholder-color);
  }

  @include element($parent, "single-value") {
    max-width: 100%;
    min-width: rem(42);
    overflow: hidden;
    text-overflow: ellipsis;
    white-space: nowrap;
  }

  @include element($parent, "multi-value") {
    padding-right: rem(5);

    &::after {
      content: ",";
    }

    &:last-of-type {
      padding-right: 0;

      &::after {
        content: none;
      }
    }
  }

  @include element($parent, "indicators") {
    flex-shrink: 0;
    align-self: stretch;
    display: flex;
    align-items: center;
    padding: rem(5) 0 rem(5) rem(10);
  }

  @include element($parent, "indicator") {
    display: flex;

    svg {
      width: var(--rs-indicator-size);
      min-width: var(--rs-indicator-size);
      height: var(--rs-indicator-size);
      fill: var(--rs-indicator-fill);
      stroke: var(--rs-indicator-stroke);
    }
  }

  @include element($parent, "menu") {
    position: absolute;
    width: 100%;
    border: 1px solid var(--rs-menu-border-color);
    border-top: 1px solid var(--rs-border-color);
    border-radius: var(--rs-menu-border-radius);
    background-color: var(--rs-menu-bg-color);
    max-height: rem(240);
    z-index: 999;
    overflow: hidden;
    box-shadow: 0px 4px rem(36) #00000014;
  }

  @include element($parent, 'menu-list') {
    @include modifier($parent, 'is-multi') {
      .#{$parent}__option--is-selected {
        background-color: var(--rs-multi-option-bg-color-is-selected);
      }
    }
  }

  @include element($parent, "option") {
    display: block;
    width: 100%;
    padding: rem(16);
    border-bottom: 1px solid var(--rs-option-border-color);
    background-color: var(--rs-option-bg-color);
    color: var(--rs-option-color);
    cursor: pointer;
    user-select: none;
    -webkit-tap-highlight-color: rgba(0, 0, 0, 0);

    &:last-child {
      background-color: transparent;
    }

    @media (hover: hover) {
      &:hover {
        background-color: var(--rs-option-bg-color-is-hover);
      }
    }

    @include modifier($parent, "is-selected") {
      background-color: var(--rs-option-bg-color-is-selected);
      color: var(--rs-option-color-is-selected);

      @include element($parent, 'multi-option-checkmark') {
        border-color: var(--rs-checkmark-border-color-is-selected);
        background-color: var(--rs-checkmark-bg-color-is-selected);
      }
    }

    @include modifier($parent, "is-focused") {
      color: var(--rs-option-color-is-focused);
    }

    @include modifier($parent, "hidden") {
      display: none;
    }
  }

  @include element($parent, "multi-option") {
    display: flex;
    align-items: center;
  }

  @include element($parent, "multi-option-input") {
    display: none;

    &:checked + .#{$parent}__multi-option-checkmark {
      svg {
        display: block;
      }
    }
  }

  @include element($parent, "multi-option-checkmark") {
    display: inline-flex;
    align-items: center;
    justify-content: center;
    width: rem(24);
    min-width: rem(24);
    height: rem(24);
    margin-right: rem(10);
    border: 1px solid var(--rs-checkmark-border-color);
    border-radius: var(--rs-checkmark-border-radius);
    background-color: var(--rs-checkmark-bg-color);

    svg {
      display: none;
      width: rem(16);
      height: rem(16);
      fill: var(--rs-checkmark-fill);
    }
  }

  @include element($parent, "multi-option-label") {
    cursor: pointer;
  }

  @include modifier($parent, 'single') {
    @include element($parent, 'control') {
      border-bottom: transparent;
      padding: 0;
    }

    @include element($parent, 'menu') {
      width: rem(240);
    }
  }

  @include modifier($parent, 'from-left') {
    @include element($parent, 'menu') {
      right: 0;
    }
  }
}
